#include "pic.h"
#include "HW_Config_p16f1823.h"

void init_hw_p16f1823(void)
{

    OSCCON = 0b01101000;    // bit7: SPLLEN = OFF
                            // bit6-3: 4MHz
                            // bit 1-0: Clock determined by Config
    //OPTION_REG = 0b01110001;  //bit6 INTEDG: 1 = INT on rising edge
    OPTION_REG = 0b00110001;    // bit7 nRAPU: 0 = enable
                                // bit6 INTEDG: 0 = INT on falling edge
                                // bit5 T0CS:   0 = internal instruction cycle clock
                                //              1 = Transition on RA2/T0CKI pin
                                // bit4 T0SE: don't care
                                // bit3 PSA: 0 = Prescaler is assigned to the Timer0 module
                                // bit2-0 PS2:PS0: 001 = 1:4

    // IO PORT
    ANSELA = 0;
    ANSELC = 0;
    PORTA = 0x00;
    TRISA = 0b00101101;
    PORTC = 0xFF;
    TRISC = 0x00;   // All output
    
    // Interruput on change
    IOCAP = 0;  //INTERRUPT-ON-CHANGE PORTA POSITIVE EDGE REGISTER
    IOCAN = 0b00101101; //INTERRUPT-ON-CHANGE PORTA NEGATIVE EDGE REGISTER
                        // active START/RA5, COURSE/RA2, GOAL/RA0

    // TMR1
    T1CON = 0b00110000; // bit7 Unimplemented
                        // bit6 TMR1GE: 0 = Timer1 is on when TMR1ON = 0
                        // bit5-4 T1CKPS1:0 : 11 = 1:8
                        // bit3 T1OSCEN: don't care
                        // bit2 not T1SYNC: don't care
                        // bit1 TMR1CS: 0 = Internal clock
                        // bit0 TMR1ON: 0 = OFF

}
