#include "pic.h"
#include "HW_Config_p16f1823.h"
#include "sound.h"

void sound_on(unsigned char note)
{
    t0_add = note;
    TMR0 = note;
    T0IE = 1;
    T0IF = 0;
    PEIE = 1;
    GIE = 1;
    T0CS = 0;   // TMR0 TMR0 Clock Source is Internal instruction cycle clock
}

void sound_off(void)
{
    T0IE = 0; //TMR0 interrupt disable
    T0CS = 1;   //TMR0 TMR0 Clock Source is not Internal instruction cycle clock
    SPK = 0;
}

void sdelay_100ms(void){
    __delay_ms(100);
}

void sdelay_200ms(void){
    __delay_ms(200);
}


void sound_on_10ms(unsigned char s, unsigned char t)
{
    // t / 10msec
    sound_on(note_ary[s]);
//    t0 = tone_prd[s];
//    TMR0 = t0;
//    INTCON = 0b11100000;            // GIE, PIE, T0IE = 1
    for(;t>0;t--)
        __delay_ms(10);
    sound_off();
}

void sound_pkmn(void){
    sound_on_10ms(7, 20);
    sdelay_200ms();
    sound_on_10ms(7, 20);
    sdelay_200ms();
    sound_on_10ms(7, 10);
    sdelay_100ms();
    sound_on_10ms(4, 10);
    sdelay_100ms();
    sound_on_10ms(12, 30);
}